Option Strict On
Option Explicit On

Imports System.Runtime.InteropServices

Module user_supplied_functions
    ' Copyright Numerical Algorithms Group 2012

    ' The user-supplied functions.

    ' Note that array arguments cannot be passed directly from
    ' the NAG C Library DLL to Visual Basic in a way in which
    ' they can be accessed. Instead, we need to pass pointers
    ' to the arrays, then use the Marshal.Copy function to
    ' get hold of the actual contents.

    ' Skeletons for call-back functions

    ' Sub fcn( _
    '   ByVal neq As Integer, _
    '   ByVal x As Double, _
    '   ByVal y_rptr As IntPtr, _
    '   ByVal f_rptr As IntPtr, _
    '   ByRef comm As Nag_User _
    ' )
    ' Insert code here.
    ' End Sub

    ' Sub pederv( _
    '   ByVal neq As Integer, _
    '   ByVal x As Double, _
    '   ByVal y_rptr As IntPtr, _
    '   ByVal pw_rptr As IntPtr, _
    '   ByRef comm As Nag_User _
    ' )
    ' Insert code here.
    ' End Sub

    ' Sub output( _
    '   ByVal neq As Integer, _
    '   ByRef xsol As Double, _
    '   ByVal y_rptr As IntPtr, _
    '   ByRef comm As Nag_User _
    ' )
    ' Insert code here.
    ' End Sub

    ' Function g( _
    '  ByVal neq As Integer, _
    '  ByVal x As Double, _
    '  ByVal y_rptr As IntPtr, _
    '  ByRef comm As Nag_User _
    ' ) As Double
    ' Insert code here.
    ' End Function

    Sub fcn(ByVal neq As Integer, ByVal x As Double, ByVal y_rptr As IntPtr, ByVal f_rptr As IntPtr, ByRef comm As Nag_User)
        Dim f(neq - 1) As Double
        Dim y(neq - 1) As Double

        ' Copy from the input array pointer y_rptr to our local array y.
        Call Marshal.Copy(y_rptr, y, 0, neq)

        f(0) = y(0) * -0.04 + y(1) * 10000.0 * y(2)
        f(1) = y(0) * 0.04 - y(1) * 10000.0 * y(2) - y(1) * 30000000.0 * y(1)
        f(2) = y(1) * 30000000.0 * y(1)

        ' Copy the array f back to the NAG C Library calling function.
        Call Marshal.Copy(f, 0, f_rptr, neq)

    End Sub

    Sub pederv(ByVal neq As Integer, ByVal x As Double, ByVal y_rptr As IntPtr, ByVal pw_rptr As IntPtr, ByRef comm As Nag_User)
        Dim pw(neq * neq - 1) As Double
        Dim y(neq - 1) As Double

        ' Copy from the input array pointer y_rptr to our local array y.
        Call Marshal.Copy(y_rptr, y, 0, neq)

        pw(0) = -0.04
        pw(1) = y(2) * 10000.0
        pw(2) = y(1) * 10000.0
        pw(neq) = 0.04
        pw(neq + 1) = y(2) * -10000.0 - y(1) * 60000000.0
        pw(neq + 2) = y(1) * -10000.0
        pw(2 * neq) = 0.0
        pw(2 * neq + 1) = y(1) * 60000000.0
        pw(2 * neq + 2) = 0.0

        ' Copy the array pw back to the NAG C Library calling function.
        Call Marshal.Copy(pw, 0, pw_rptr, neq * neq)

    End Sub

    Sub output(ByVal neq As Integer, ByRef xsol As Double, ByVal y_rptr As IntPtr, ByRef comm As Nag_User)
        Dim i As Integer
        Dim y(neq - 1) As Double
        Dim mycomm(3) As Double
        Dim xend, h, k As Double
        Dim outstr As String

        ' Copy from the input array pointer y_rptr to our local array y.
        Call Marshal.Copy(y_rptr, y, 0, neq)
        ' Copy elements pointed to by comm into local array mycomm
        Call Marshal.Copy(comm.p, mycomm, 0, 4)

        xend = mycomm(1)
        k = mycomm(2)
        h = mycomm(3)

        outstr = Format(xsol, "######0.00000")

        For i = 0 To neq - 1
            outstr = outstr & "  " & Format(y(i), "######0.00000")
        Next i
        d02ejcForm.ResultsList.Items.Add(outstr)
        xsol = xend - k * h
        mycomm(2) = k - 1

        ' Copy the array mycomm back to the NAG C Library calling function.
        Call Marshal.Copy(mycomm, 0, comm.p, 4)

    End Sub

    Function g(ByVal neq As Integer, ByVal x As Double, ByVal y_rptr As IntPtr, ByRef comm As Nag_User) As Double
        Dim y(neq - 1) As Double

        ' Copy from the input array pointer y_rptr to our local array y.
        Call Marshal.Copy(y_rptr, y, 0, neq)

        g = y(0) - 0.9

    End Function
End Module
